#pragma once

#define DBG_LOG 1
#include "BKTools.h"

struct BKPParam
{
	uint16_t    DSHORT; //       
	//    ,    0,  022
	uint16_t    C2;     //   ..
	uint16_t    C1;     //   ..
	uint8_t     BESC2;  //  ESC2
	uint8_t     BESC1;  //  ESC1
	uint16_t    AWREG;  //   
	uint16_t    DELJMP; //      
	uint16_t    LENAZ;  //      1000 ( )
	uint16_t    EDAT;   //   
	uint16_t    BDAT;   //    
	uint16_t    LENAUN; //    
	uint16_t    LENW;   //     
	uint16_t    NTW;    //    TB  TW( ESC)
	uint16_t    CNTEC1; //     
	uint16_t    DELW;   //   
	uint16_t    ABEG;   //   
	uint16_t    LENP;   //   
	uint16_t    N1B;    //  DELW,  
	uint16_t    NTWB;   //   TW
	uint16_t    EPK;    //    + AUNP

	bool        bData;          //  Code/Data (false - , true - )
	bool        bLongUnpacker;  //  Short/Long  (false - , true - )
	//    
	uint16_t    nFileLen;   //  
	uint16_t    nChecksum;  //   
};

struct Pair
{
	uint16_t nMulti;    // 
	uint16_t nWord;     // 
};

extern MemoryModel MMemory;
extern BKPParam BKPkParam;

constexpr auto LENMAS = 01000;
constexpr auto LENMAS_W = 0400;
constexpr auto SB_SIZE = 040;

extern uint16_t TW[LENMAS_W];
extern uint16_t BKPackAUNP[];

//   ,       
#define MAXLEN 074000
//      
#define LUNPF$  2
#define CS$     016
#define WE$     034
#define C1$     060
#define C2$     072
#define WB$     0104
#define LPK1$   0122
#define LAUN$   0126
#define LUNP$   0140
#define WH$     0150
#define DELW1$  0164
#define EOFS$   0216
#define EOFS2$  0220

bool SEARCH(uint16_t *m, int nLen, int &nIdx, uint16_t w);
bool CWB(uint16_t &R5);
void UNPK(int R1, int R4);
bool BKPacking(int nFileLoadAddr, int nFileLen, int nFileActualAddr);
bool BKUnPacking(int nFileLoadAddr, int nFileLen, int nFileActualAddr);

