#pragma once

enum OP_MODE
{
	UNKN,
	LINK,
	COMP,
	CL
};

int workCycle(std::wstring &strInFileName);
void Usage();
bool SkipTailString(wchar_t &ch);
void ParseLine();
void SaveFile(const std::wstring &strName);
void PrintLabelTable(const std::wstring &strName, const std::wstring &strExt);

//       
std::wstring trim(const std::wstring &str, const wchar_t trim_char = L' ');
//      
std::wstring trimLeft(const std::wstring &str, const wchar_t trim_char = L' ');
//      
std::wstring trimRight(const std::wstring &str, const wchar_t trim_char = L' ');

std::wstring strToLower(const std::wstring &str);
