#pragma once

#include "Reader.h"

//        
struct GlobalParams
{
	std::wstring strAppPath;    //  
	bool bVerbosity;
	bool bInString;             // ,     ""  ascii, asciz  rad50
	bool bOperandType;          // ,  . false = dd, true = ss,  OPssdd
	bool bENDReached;           // ,    .end
	bool bStopOnError;          //       
	bool bLinkerFirst;          //    
	int nModeLinkage;           //   : -1 = CL, 1 = CO, 0 =    .end
	int nAriphmType;            //   ,   : -1 = , 1 - word   , 0 -  
	int nStartAddress;          //       01000 == -
	int nPC;                    //  PC  ,   .
	int nProgramLength;         //   
	int nError;                 //   ,   .
	bool bStepInclude;          // ,  ,           
	bool bInvert;               //   ^C, ,     
};


extern GlobalParams g_GlobalParameters;

union UMemory
{
	uint16_t w[32768];
	uint8_t  b[65536];
};

extern UMemory g_Memory;
extern CReader *g_pReader;
extern std::vector <CReader *> v_Reader;
extern CReader::FILE_CHARSET Charset;

constexpr auto BASE_ADDRESS = 0;
constexpr auto START_ADDRESS_OFFSET = 01000;
constexpr auto HIGH_BOUND = 0177000;

void InitGlobalParameters(GlobalParams *gp);
void ReInitGlobalParameters(GlobalParams *gp);
void SetStartAddress(int addr);
int GetStartAddress();
int CorrectAddress(int addr);
int CorrectOffset(int addr);

