#include "pch.h"
#include "BKPack.h"
#pragma warning(disable:4996)


int g_nTableOffset = 0;
/*
 ,   

nFileLoadAddr -      MMemory,  0
nFileLen -  ,    MMemory
nFileActualAddr -     ,       .
*/
bool PackAnalyse(int nFileLoadAddr, int nFileLen, int nFileActualAddr)
{
	//  ,   .
	int nOffset = 01000 - nFileActualAddr; //    < 01000,     
	BKPkParam.LENAZ = 0;
	BKPkParam.BDAT = nFileLoadAddr;

	if (nOffset > 0)
	{
		BKPkParam.LENAZ = nOffset; //   
		BKPkParam.BDAT += nOffset; //   
	}

	//   
	BKPkParam.DSHORT = 022; //    

	if (MMemory.w[BKPkParam.BDAT / 2 + 3] == 0266 && MMemory.w[BKPkParam.BDAT / 2 + 5] == 0350)
	{
		BKPkParam.bLongUnpacker = true;
		BKPkParam.DSHORT = 0;
	}

	bool bOk = true;
	//  ,    bkpack  ?
	int nBase = BKPkParam.BDAT - BKPkParam.DSHORT;
	//  2     
	int wBase = nBase / 2; //    
	int k = 0130 / 2; //    
	bool bNoInt1 = false;

	for (auto n = 0; n < 4; ++n) //  4 
	{
		if (MMemory.w[wBase + k] != BKPackAUNP[k]) //    ,  
		{
			bNoInt1 = true; //    
		}

		k++;
	}

	k += 11; //    
	bool bNoInt2 = false;

	for (auto n = 0; n < 12; ++n) //  12 
	{
		if (MMemory.w[wBase + k] != BKPackAUNP[k]) //    ,  
		{
			bNoInt2 = true; //    
		}

		k++;
	}

	if (bNoInt1 && bNoInt2) //      ,     
	{
		return false;
	}

	//  ,   
	//     
	if (MMemory.w[(nBase + EOFS$) / 2] == 0207)
	{
		BKPkParam.bData = true;
	}

	//    
	if (MMemory.w[(nBase + EOFS$) / 2] == 0137 || MMemory.w[(nBase + EOFS$) / 2] == 04737)
	{
		BKPkParam.AWREG = 0137; //  ,   EOFS2$   ,   
	}

	BKPkParam.C1 = MMemory.w[(nBase + C1$) / 2];
	BKPkParam.C2 = MMemory.w[(nBase + C2$) / 2];
	BKPkParam.DELW = MMemory.w[(nBase + DELW1$) / 2] - 1;
	BKPkParam.LENAUN = MMemory.w[(nBase + LAUN$) / 2]; //    
	g_nTableOffset = MMemory.w[(nBase + 026) / 2] + nBase + 024;
	BKPkParam.EPK = nFileLoadAddr + nFileLen; //     
	BKPkParam.nFileLen = MMemory.w[(nBase + LUNP$) / 2]; //    
	BKPkParam.DELJMP = MMemory.w[(nBase + EOFS2$) / 2]; //   
	return true;
}

//   TWB.
uint16_t ExpandTW()
{
	memset(TW, 0, sizeof(TW));
	uint16_t R4 = g_nTableOffset; //  TWB
	uint16_t R0 = R4; //  SB
	int R3 = LENMAS_W;
	uint16_t R1 = 0;

	do
	{
		R0 -= 2;
		uint16_t nBit = 1 << 15;

		for (int R2 = 0; R2 < 020; ++R2)
		{
			TW[--R3] = 0;

			if (MMemory.w[R0 / 2] & nBit)
			{
				auto R5 = short(char(MMemory.b[R4++]));
				R5 -= BKPkParam.C1;

				if (R5 >= 0)
				{
					R5 <<= 8;
					R5 |= MMemory.b[R4++];
					R5 -= BKPkParam.C2;
				}

				R1 -= R5;
				TW[R3] = R1;
			}

			nBit >>= 1;
		}
	}
	while (R3 > 0);

#if defined(_DEBUG) && defined(DBG_LOG)
	FILE *tf = fopen("TW_unp.txt", "wt");
	int n = 0;
	int r = 037000;

	for (int i = 0; i < LENMAS_W / 4; ++i)
	{
		fprintf(tf, "%06o: %06o ", r, TW[n++]);
		fprintf(tf, "%06o ", TW[n++]);
		fprintf(tf, "%06o ", TW[n++]);
		fprintf(tf, "%06o\n", TW[n++]);
		r += 010;
	}

	fclose(tf);
#endif
	return R0;
}

void BKUnpack()
{
	//    
	int R0 = BKPkParam.EPK;
	int R2 = BKPkParam.LENAUN; //    
	int R4 = BKPkParam.BDAT + R2;

	for (int i = 0; i < R2; ++i)
	{
		MMemory.b[--R4] = MMemory.b[--R0];
	}

	//  
	R4 += BKPkParam.nFileLen;
	uint16_t R1 = 0;

	do
	{
		assert(R0 > 0);
		short i = short(char(MMemory.b[--R0])) + LENMAS_W / 2;

		if (0 <= i && i < LENMAS_W)
		{
			R1 = TW[i];
		}
		else
		{
			assert(false);
		}

		if (R1 == 0)
		{
			MMemory.b[--R4] = MMemory.b[R0];
			MMemory.b[--R4] = MMemory.b[--R0];
		}
		else if (R1 == 1)
		{
			int R2 = MMemory.b[--R0];

			if (R2 == 0)
			{
				R2 = 0400;
			}

			for (int i = 0; i < R2; ++i)
			{
				uint16_t w = MMemory.w[R4 / 2];
				R4 -= 2;
				MMemory.w[R4 / 2] = w;
			}
		}
		else if (R1 == 0100000)
		{
			MMemory.b[--R4] = MMemory.b[--R0];
			MMemory.b[--R4] = MMemory.b[--R0];
		}
		else
		{
			R1 += BKPkParam.DELW;
			R4 -= 2;
			MMemory.w[R4 / 2] = R1;
		}
	}
	while (R4 != R0);

	if (BKPkParam.AWREG != 0137)
	{
		BKPkParam.DELJMP += R0; //   .
	}

	// ,    ,      
	if (BKPkParam.LENAZ && !BKPkParam.bData)
	{
		int R0 = BKPkParam.BDAT - 012; //     766

		if (R0 < g_nFileLoadAddress)
		{
			R0 = g_nFileLoadAddress; //     - 
		}

		uint16_t wStart = MMemory.w[R0 / 2]; // ,     
		R0 = BKPkParam.BDAT - 034; //     744

		if (R0 < g_nFileLoadAddress)
		{
			R0 = g_nFileLoadAddress; //     - 
		}

		//    
		while (MMemory.w[R0 / 2] == wStart && R0 < BKPkParam.BDAT)
		{
			R0 += 2;
		}

		R0 -= 4;

		if (R0 < g_nFileLoadAddress)
		{
			R0 = g_nFileLoadAddress; //     - 
		}

		do
		{
			MMemory.w[R0 / 2] = BKPkParam.DELJMP; //     ,    
			R0 -= 2;
		}
		while (R0 >= g_nFileLoadAddress && MMemory.w[R0 / 2] == wStart);   //   ,   
	}
}


bool BKUnPacking(int nFileLoadAddr, int nFileLen, int nFileActualAddr)
{
	if (PackAnalyse(nFileLoadAddr, nFileLen, nFileActualAddr))
	{
		uint16_t R0 = ExpandTW();
		R0 -= 034 * 2; //  .  ,      
		R0 += MMemory.w[(BKPkParam.BDAT - BKPkParam.DSHORT + 0122) / 2]; //    ,     

		if (R0 > BKPkParam.EPK)
		{
			wprintf(L"::   .  .\n");
			return false;
		}

		BKPkParam.EPK = R0; //    
		BKUnpack();
		wprintf(L" OK\n");
		return true;
	}

	wprintf(L"::    BKPack   .\n");
	return false;
}

